package com.example.lingobeemod;

import java.util.ArrayList;

import android.app.Activity;
import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.TextView;

public class CustomAdapter extends ArrayAdapter<Custom>{
	private ArrayList<Custom> entries;
	private Activity activity;

	public CustomAdapter(Activity a, int textViewResourceId, ArrayList<Custom> entries) {
		super(a, textViewResourceId, entries);
		this.entries = entries;
		this.activity = a;
	}

	public static class ViewHolder{
		public TextView item1;
		public TextView item2;
		public TextView item3;
	}

	@Override
	public View getView(int position, View convertView, ViewGroup parent) {
		View v = convertView;
		ViewHolder holder;
		if (v == null) {
			LayoutInflater vi =
					(LayoutInflater)activity.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
			v = vi.inflate(R.layout.listviewrow, null);
			holder = new ViewHolder();
			holder.item1 = (TextView) v.findViewById(R.id.ratingTextView);
			holder.item2 = (TextView) v.findViewById(R.id.userIdTextView);
			holder.item3 = (TextView) v.findViewById(R.id.pointTextView);
			v.setTag(holder);

		}
		else
			holder=(ViewHolder)v.getTag();

		final Custom custom = entries.get(position);
		if (custom != null) {
			holder.item1.setText(custom.getRating());
			holder.item2.setText(custom.getUserId());
			holder.item3.setText(custom.getPoints());
		}
		return v;
	}

}