package com.example.lingobeemod;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.security.MessageDigest;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Locale;

import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;

import org.apache.http.HttpResponse;
import org.apache.http.NameValuePair;
import org.apache.http.client.HttpClient;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.message.BasicNameValuePair;
import org.xml.sax.InputSource;
import org.xml.sax.XMLReader;

import android.content.Context;
import android.os.Bundle;
import android.os.StrictMode;
import android.text.style.UpdateAppearance;
import android.util.Log;

public class LingoServerQuery {

	static List<XMLnodes> myData = null;
	private static boolean successQuery = false;
	private static InternalDatabaseHandler db;
	private static String parseQuery;
	private static HttpClient client = new DefaultHttpClient();
	private static HttpPost post = new HttpPost("http://itrg.brighton.ac.uk/lingobee/api/0.5/lingoserver.php");
	private static String str1 = new SimpleDateFormat("yyyyMMddHHmmss", Locale.UK).format(new Date());;
	

/* 

This key is necessary for application to work, and is provided by the Lingobee developers. This key is private, and has been removed from this code due to this.   private static String str2 = md5(str1 + "<INSERT PRIVATE KEY PROVIDED BY LINGOBEE>");

*/
	private static List<NameValuePair> nameValuePairs;
	private static HttpResponse response;
	private static String uid;
	private static boolean needUpdate = false;

	public LingoServerQuery(){
	}  

	public static boolean executeQuery(List<NameValuePair> queryParams, String query, String userId){
		BufferedReader rd;	
		parseQuery = query;
		if(db.getAllWords().size() == 0) {
			needUpdate = true;
		}
		try {
			nameValuePairs = new ArrayList<NameValuePair>(1);
			nameValuePairs.add(new BasicNameValuePair("api", "0.5"));
			nameValuePairs.add(new BasicNameValuePair("key", "Ed2E42fMPd5BCVaG2bH3J9fW65By8JUI"));
			nameValuePairs.add(new BasicNameValuePair("cid", str1));
			nameValuePairs.add(new BasicNameValuePair("sig", str2));
			nameValuePairs.add(new BasicNameValuePair("uid", userId));
			nameValuePairs.add(new BasicNameValuePair("fmt", "xml"));
			nameValuePairs.add(new BasicNameValuePair("q", query));

			for(int i = 0; i < queryParams.size(); i++) {
				nameValuePairs.add(queryParams.get(i));
			}
			post.setEntity(new UrlEncodedFormEntity(nameValuePairs));
			response = client.execute(post);
			rd = new BufferedReader(new InputStreamReader(response.getEntity().getContent()));
			parseXML(rd);			
			rd.close();
			successQuery = true;
		} catch (IOException e) {
			e.printStackTrace();
		}
		return successQuery;
	}

	public static String lingoQuery(Context c, String query, List<NameValuePair> queryParams, String userId){
		if(userId.equals("0")){
			uid = "0";
		}else {
			uid = userId;
		}
		db = new InternalDatabaseHandler(c);
		parseQuery = query;
		StrictMode.ThreadPolicy policy = new StrictMode.ThreadPolicy.Builder().permitAll().build();
		StrictMode.setThreadPolicy(policy);
		
		if(executeQuery(queryParams, query, uid)){
			return uid;
		}
		return "-1";
	}

	public static XMLnodes parseXML(BufferedReader rd){
		Log.i("Parsing: ", "Started");
		try{
			InputSource is = new InputSource(rd);
			XMLParser parser = new XMLParser();
			SAXParserFactory factory = SAXParserFactory.newInstance();
			SAXParser sp = factory.newSAXParser();
			XMLReader reader = sp.getXMLReader();
			reader.setContentHandler(parser);
			reader.parse(is);		

			if(parseQuery.equals("signin")) {
				myData = parser.list;
				if(myData != null){
					for (XMLnodes xmlRowData : myData) {
						uid = parser.nodes.getId_user();
						User user = new User();
						user.setID_USER(xmlRowData.getId_user());
						user.setID_GROUP(xmlRowData.getId_group());
						db.addUser(user);
						successQuery = true;
					}
				}

			}else if (parseQuery.equals("getWordList")){
				myData = parser.list;	
				boolean update = false;
				Log.i("UPDATES", ""+update);
				if(db.getAllWords().size() != 0) {
					String a = myData.get(0).getId_word();
					String b = db.getAllWords().get(0).getID_WORD();
					update = a.equalsIgnoreCase(b);
					Log.i("UPDATES", ""+update);
				}
				if(!update || db.getAllWords().size() == 0) {
					Log.i("UPDATES", ""+update);
					needUpdate = true;
					db.deleteAllWords();
					for (XMLnodes xmlRowData : myData) {
						if(xmlRowData !=null)
						{ 
							Word word = new Word();
							word.setID_WORD(xmlRowData.getId_word());
							word.setWORD(xmlRowData.getWord());
							word.setID_USER(xmlRowData.getId_user());
							word.setCAT(xmlRowData.getCat());
							word.setFLAG(xmlRowData.getFlag());
							word.setLINK(xmlRowData.getLink());
							word.setIMAGE(xmlRowData.getImage());
							word.setAUDIO(xmlRowData.getAudio());
							db.addWord(word);
						}
					}
				}
			}
			else if (parseQuery.equals("getWord")){
				myData = parser.list;
				String a = myData.get(0).getId_word();
				String b = db.getAllWords().get(0).getID_WORD();
				if(needUpdate) {
					if(myData != null){
						for (XMLnodes xmlRowData : myData) {
							if(xmlRowData!=null)
							{ 
								Word word = new Word();
								word.setID_WORD(xmlRowData.getId_word());
								word.setWORD(xmlRowData.getWord());
								word.setID_USER(xmlRowData.getId_user());
								word.setCAT(xmlRowData.getCat());
								word.setFLAG(xmlRowData.getFlag());
								word.setLINK(xmlRowData.getLink());
								word.setIMAGE(xmlRowData.getImage());
								word.setAUDIO(xmlRowData.getAudio());

								User newUser = new User();
								newUser.setID_USER(xmlRowData.getId_user());
								newUser.setUSERNAME(xmlRowData.getUsername());
								db.addUser(newUser);	
								db.updateUser(newUser);
								db.updateWord(word);
							}
						}
					}
				}
			}
		}
		catch(Exception e){Log.e("Parser Exception :" , ""+e);}
		return null;
	}

	public static final String md5(String paramString)

	{
		try
		{
			MessageDigest localMessageDigest = MessageDigest.getInstance("MD5");
			localMessageDigest.update(paramString.getBytes());
			byte[] arrayOfByte = localMessageDigest.digest();
			StringBuffer localStringBuffer = new StringBuffer();
			for (int i = 0;; i++)
			{
				if (i >= arrayOfByte.length) {
					return localStringBuffer.toString();
				}
				String str = Integer.toHexString(0xFF & arrayOfByte[i]);
				if (str.length() < 2) {
					localStringBuffer.append(0);
				}
				localStringBuffer.append(str);
			}
		}
		catch (Exception localException)
		{
		}
		return "";
	}
	public static boolean getUpdateNeeded(){
		return needUpdate;
	}
} 