package com.example.lingobeemod;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.nio.channels.FileChannel;
import java.util.ArrayList;
import java.util.List;

import org.apache.http.NameValuePair;
import org.apache.http.message.BasicNameValuePair;

import com.google.analytics.tracking.android.EasyTracker;

import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.opengl.Visibility;
import android.os.Bundle;
import android.os.Environment;
import android.os.Handler;
import android.util.Log;
import android.view.Menu;
import android.view.View;
import android.widget.CheckBox;
import android.widget.CompoundButton;
import android.widget.EditText;
import android.widget.RelativeLayout;
import android.widget.Toast;

public class MainActivity extends Activity {
	private EditText userNameInput;
	private EditText passwordInput;
	private static Context context;
	private CheckBox remembermeCheckBox;
	private static boolean checkBox;

	private static RelativeLayout loadingScreen;
	Bundle b = new Bundle();
	protected InternalDatabaseHandler db = new InternalDatabaseHandler(this);
	private boolean _doubleBackToExitPressedOnce = false;


	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);
		EasyTracker.getInstance(this).activityStart(this);  
		loadingScreen = (RelativeLayout)findViewById(R.id.loadingRelativeLayout);
		remembermeCheckBox = (CheckBox)findViewById(R.id.remembermeCheckBox);
		userNameInput   = (EditText)findViewById(R.id.userNameInput);
		passwordInput   = (EditText)findViewById(R.id.passwordInput);
		context = getApplicationContext();


		List<LoginCredencials> userLogin = db.getRememberedLoginCredencials();
		Log.i("USERLOGIN", ""+userLogin.size());

		if(userLogin.size()>0) {
			userNameInput.setText(userLogin.get(0).getLogin());
			passwordInput.setText(userLogin.get(0).getPassword());
			remembermeCheckBox.setChecked(true);
			checkBox = true;
		}

		remembermeCheckBox.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
			@Override
			public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
				if(isChecked) {
					checkBox = true;
				}else {
					checkBox = false;
				}

			}
		});
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.main, menu);
		return true;
	}

	public void systemExit(View v){
		if (checkBox == false) {
			userNameInput.setText("");
			passwordInput.setText("");
			db.deletePass();
		}
		EasyTracker.getInstance(this).activityStop(this);
		Intent intent = new Intent(Intent.ACTION_MAIN);
		intent.addCategory(Intent.CATEGORY_HOME);
		intent.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
		startActivity(intent);
	}

	public void submitLoginInfo(View v){
		String userName = userNameInput.getText().toString();
		String passWord = passwordInput.getText().toString();

		List<NameValuePair> nameValuePairs = new ArrayList<NameValuePair>();
		nameValuePairs.add(new BasicNameValuePair("username", userName));
		nameValuePairs.add(new BasicNameValuePair("userpass", passWord));

		String firstLoginUID = "0";
		String afterLogin = null;

		try {
			afterLogin = LingoServerQuery.lingoQuery(context, "signin", nameValuePairs, firstLoginUID);
			Log.i("Afterlogin equals try", afterLogin);
		} catch (Exception e) {
			Log.i("Afterlogin equals catch", afterLogin);
		}
		if(afterLogin.equals("-1") || afterLogin.equals("0")) {
			Toast.makeText(getApplicationContext(), "Error in username and/or password", Toast.LENGTH_LONG).show();
		}else {
			if(checkBox) {
				db.deletePass();
				LoginCredencials lc = new LoginCredencials();
				String username = userNameInput.getText().toString();
				String password = passwordInput.getText().toString();
				lc.setLogin(username);
				lc.setPassword(password);				
				db.addPass(lc);
			}else {
				db.deletePass();
			}
			Intent intent = new Intent(this, SplashScreen.class);
			loadingScreen.setVisibility(View.VISIBLE);
			loadingScreen.setClickable(false);
			b.putInt("key", Integer.parseInt(afterLogin)); //Your id
			b.putString("uname", userNameInput.getText().toString());
			Log.i("Username", ""+userNameInput.getText());
			intent.putExtras(b); //Put your id to your next Intent		

			startActivity(intent);
		}
	}

	public void startNext(Intent i){
		EasyTracker.getInstance(this).activityStop(this);
		startActivity(i);
		finish();
	}
	@Override
	public void onBackPressed() {
	    if (_doubleBackToExitPressedOnce) {
	    	Intent intent = new Intent(Intent.ACTION_MAIN);
	    	intent.addCategory(Intent.CATEGORY_HOME);
	    	intent.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
	    	startActivity(intent);
	        return;
	    }
	    this._doubleBackToExitPressedOnce = true;
	    Toast.makeText(this, "Press again to quit", Toast.LENGTH_SHORT).show();
	    new Handler().postDelayed(new Runnable() {
	        @Override
	        public void run() {
	            _doubleBackToExitPressedOnce = false;
	        }
	    }, 2000);
	}
}
