package com.example.lingobeemod;

import java.util.HashMap;

import android.os.Bundle;
import android.os.Handler;
import android.app.Activity;
import android.content.Intent;
import android.graphics.Point;
import android.util.Log;
import android.view.Display;
import android.view.Gravity;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.ViewGroup.LayoutParams;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.RelativeLayout;
import android.widget.TextView;
import android.widget.Toast;

import com.google.analytics.tracking.android.EasyTracker;
import com.google.analytics.tracking.android.Fields;
import com.google.analytics.tracking.android.GoogleAnalytics;
import com.google.analytics.tracking.android.Tracker;

public class MenuActivity extends Activity {

	private String ID; 
	private static int userPoints;
	private static TextView statusTextView;
	private static ImageView statusImageView;
	private Bundle b;
	private static RelativeLayout needMorePostsLayout;
	protected InternalDatabaseHandler db = new InternalDatabaseHandler(this);
	private static RelativeLayout aboutLayout ;
	private static int width; 
	private static LinearLayout ll;
	private static LinearLayout.LayoutParams layoutPicture;
	private boolean _doubleBackToExitPressedOnce    = false;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_menu);
		aboutLayout = (RelativeLayout) findViewById(R.id.aboutLayout);

		b = getIntent().getExtras();
		ID = ""+b.getInt("key");
		needMorePostsLayout = (RelativeLayout)findViewById(R.id.needMorePostsLayout);

		//User status stuff
		userPoints = Integer.parseInt(db.getUser(ID).getPOINTS());
		Display d = getWindowManager().getDefaultDisplay();
		Point size = new Point();
		d.getSize(size);
		width = size.x;		
		statusImageView = (ImageView)findViewById(R.id.statusImageView);
		statusTextView = (TextView)findViewById(R.id.statusTextView);

		layoutPicture = new LinearLayout.LayoutParams(
				(width/2), 
				(width/2));
		layoutPicture.gravity = Gravity.CENTER_VERTICAL;
		checkPointsAchievements();

		//Google analytics
		EasyTracker.getInstance(this).activityStart(this);  
		Tracker tracker = GoogleAnalytics.getInstance(this).getTracker("UA-47809711-1");
		HashMap<String, String> hitParameters = new HashMap<String, String>();
		hitParameters.put(Fields.HIT_TYPE, "Login by " + db.getUser(ID).getUSERNAME());
		hitParameters.put(Fields.SCREEN_NAME, "Home Screen");
		tracker.send(hitParameters);

	}

	public void checkPointsAchievements(){
		if(userPoints > 10) {
			String text = "!!! KING !!!";
			int pointPicture6 = R.drawable.points6;			
			addAchievement(pointPicture6, text);
		}else if(userPoints > 8) {
			String text = "Going for the throne eyy?";
			int pointPicture5 = R.drawable.points5;			
			addAchievement(pointPicture5, text);
		}else if(userPoints > 6) {
			String text = "Power user";
			int pointPicture4 = R.drawable.points4;			
			addAchievement(pointPicture4, text);
		}else if(userPoints > 5) {
			String text = "Average user";
			int pointPicture3 = R.drawable.points3;			
			addAchievement(pointPicture3, text);
		}else if(userPoints > 2) {
			String text = "Normal user";
			int pointPicture2 = R.drawable.pointsnr2;			
			addAchievement(pointPicture2, text);
		}else if(userPoints > 1) {
			String text = "Newcomer";
			int pointPicture1 = R.drawable.pointsachievement;			
			addAchievement(pointPicture1, text);
		}
	}

	public void addAchievement(int pointsachievement, String text){
		statusTextView.setText(text);			
		statusImageView.setImageResource(pointsachievement);
	}
	public void startTop(View v) {
		b.putInt("key", Integer.parseInt(ID)); //Your id
		Intent intent = new Intent(this, TopViewActivity.class);
		intent.putExtras(b); //Put your id to your next Intent
		EasyTracker.getInstance(this).activityStop(this);
		startActivity(intent);
	}

	public void closeNeedMorePosts(View v){
		needMorePostsLayout.setVisibility(View.GONE);
	}

	@Override
	public void onStart() {
		super.onStart();
		// The rest of your onStart() code.
		EasyTracker.getInstance(this).activityStart(this);  
	}

	public void startStats(View v){
		b.putInt("key", Integer.parseInt(ID)); //Your id
		Intent intent = new Intent(this, UserViewActivity.class);
		intent.putExtras(b); //Put your id to your next Intent
		Log.i("Start statistic ativity with id", ""+ ID);
		Log.i("Start statistic ativity with points", ""+ db.getUser(ID).getPOINTS());
		int points = Integer.parseInt(db.getUser(ID).getPOSTPOINTS());
		if(points <= 0) {
			needMorePostsLayout.setVisibility(View.VISIBLE);
		}else {
			EasyTracker.getInstance(this).activityStop(this);
			startActivity(intent);
		}
	}


	@Override
	public void onBackPressed() {
	    if (_doubleBackToExitPressedOnce) {
	    	Intent intent = new Intent(Intent.ACTION_MAIN);
	    	intent.addCategory(Intent.CATEGORY_HOME);
	    	intent.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
	    	startActivity(intent);
	        return;
	    }
	    this._doubleBackToExitPressedOnce = true;
	    Toast.makeText(this, "Press again to quit", Toast.LENGTH_SHORT).show();
	    new Handler().postDelayed(new Runnable() {
	        @Override
	        public void run() {
	            _doubleBackToExitPressedOnce = false;
	        }
	    }, 2000);
	}

	public void systemExit(View v){
		Intent backIntent = new Intent(this, MainActivity.class);
		startActivity(backIntent);
		EasyTracker.getInstance(this).activityStop(this);
		finish();
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.menu, menu);
		return true;
	}

	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		// Handle presses on the action bar items
		switch (item.getItemId()) {
		case R.id.action_information:
			aboutLayout.setVisibility(View.VISIBLE);
			return true;
		default:
			return super.onOptionsItemSelected(item);
		}
	}
	public void closeAbout(View v) {
		aboutLayout.setVisibility(View.INVISIBLE);
	}
}
