package com.example.lingobeemod;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

import org.apache.http.NameValuePair;
import org.apache.http.message.BasicNameValuePair;

import android.app.Activity;
import android.content.Intent;
import android.opengl.Visibility;
import android.os.Bundle;
import android.os.Handler;
import android.util.Log;
import android.view.Menu;
import android.view.View;
import android.widget.TextView;

public class ParseLoadActivity extends Activity {

	private static InternalDatabaseHandler db;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_parse_load);
		runUpdates();
	}

	protected void runUpdates() {
		super.onResume();
		Bundle b = getIntent().getExtras();
		String id = ""+b.getInt("key");
		String uname = b.getString("uname");

		List<NameValuePair> nameValuePairs = new ArrayList<NameValuePair>();
		nameValuePairs.add(new BasicNameValuePair("limit", "500"));
		db = new InternalDatabaseHandler(this);

		if(LingoServerQuery.executeQuery(nameValuePairs, "getWordList", id)) {
			Log.i("Wordlist acuired: " , "Success");
			for(int i = 0; i < db.getAllWords().size(); i++){
				List<NameValuePair> wordPair = new ArrayList<NameValuePair>();
				wordPair.add(new BasicNameValuePair("id_word", db.getAllWords().get(i).getID_WORD()));
				LingoServerQuery.executeQuery(wordPair, "getWord", id);
			}

			//Update user with the different points
			if(LingoServerQuery.getUpdateNeeded()){
				for(int i = 0; i < db.getAllUsers().size(); i++){
					String userID = db.getAllUsers().get(i).getID_USER();
					int points = updateCategoryAmount(userID)+
							updateImageAmount(userID)+
							updateAudioAmount(userID)+
							updateFlagAmount(userID)+
							db.getAllWordsByUser(userID).size()+
							updateLinkAmount(userID);
					User user = db.getUser(userID);
					user.setCATEGORYPOINTS(""+updateCategoryAmount(userID));
					user.setIMAGEPOINTS(""+updateImageAmount(userID));
					user.setAUDIOPOINTS(""+updateAudioAmount(userID));
					user.setFLAGPOINTS(""+updateFlagAmount(userID));
					user.setPOSTPOINTS(""+db.getAllWordsByUser(userID).size());	
					user.setLINKPOINTS(""+updateLinkAmount(userID));
					user.setPOINTS(""+points );
					db.updateUser(user);
				}
			}
		} else {
			Log.i("UPDATE" , "Failed / No updated needed");
		}

		b.putInt("key", Integer.parseInt(id)); //Your id
		Intent intent = new Intent(this, MenuActivity.class);
		intent.putExtras(b); //Put your id to your next Intent
		startActivity(intent);

	}
	private int updateCategoryAmount(String id){
		List<String> catList = new ArrayList<String>();			
		catList = db.getAllCatsByUser(id);			
		HashMap<String, Integer> catPointsHashMap = new HashMap<String, Integer>();
		for(int i = 0; i < catList.size(); i++) {
			catPointsHashMap.put(catList.get(i), +1);
		}
		Log.i("updateCategoryAmount is" , "" + db.getAllCatsByUser(id).size());
		return catPointsHashMap.size();
	}

	private int updateImageAmount(String id){
		List<String> list = new ArrayList<String>();			
		list = db.getAllImagesByUser(id);			
		HashMap<String, Integer> hashMap = new HashMap<String, Integer>();
		for(int i = 0; i < list.size(); i++) {
			hashMap.put(list.get(i), +1);
		}
		Log.i("updateImageAmount is" , "" + db.getAllImagesByUser(id).size());
		return (hashMap.size()-1);
	}

	private int updateAudioAmount(String id){
		List<String> list = new ArrayList<String>();			
		list = db.getAllAudioByUser(id);			
		HashMap<String, Integer> hashMap = new HashMap<String, Integer>();
		for(int i = 0; i < list.size(); i++) {
			hashMap.put(list.get(i), +1);
		}
		Log.i("Updateaudioamount is" , "" + db.getAllAudioByUser(id).size());
		return (hashMap.size()-1);
	}

	private int updateFlagAmount(String id){
		List<String> list = new ArrayList<String>();			
		list = db.getAllFlagsByUser(id);			
		HashMap<String, Integer> hashMap = new HashMap<String, Integer>();
		for(int i = 0; i < list.size(); i++) {
			hashMap.put(list.get(i), +1);
		}
		Log.i("Updateflagamount is" , "" + db.getAllFlagsByUser(id).size());
		return (hashMap.size()-1);
	}

	private int updateLinkAmount(String id){
		List<String> list = new ArrayList<String>();			
		list = db.getAllLinksByUser(id);			
		HashMap<String, Integer> hashMap = new HashMap<String, Integer>();
		for(int i = 0; i < list.size(); i++) {
			hashMap.put(list.get(i), +1);
		}
		Log.i("UpdateLinkAmount is" , "" + db.getAllLinksByUser(id).size());
		return (hashMap.size()-1);
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.parse_load, menu);
		return true;
	}

	@Override
	public void onBackPressed() {
	}
}
