package com.example.lingobeemod;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

import org.apache.http.NameValuePair;
import org.apache.http.message.BasicNameValuePair;

import android.app.Activity;
import android.app.ProgressDialog;
import android.content.Intent;
import android.os.AsyncTask;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.ProgressBar;
import android.widget.TextView;

public class SplashScreen extends Activity {

	private static InternalDatabaseHandler db;
	private static Bundle b;
	private static String id;
	private static String uname;
	private ProgressBar spinner;
	private static TextView loaderText;
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_parse_load);

		/**
		 * Showing splashscreen while making network calls to download necessary
		 * data before launching the app Will use AsyncTask to make http call
		 */
		db = new InternalDatabaseHandler(this);
		spinner = (ProgressBar)findViewById(R.id.progressBar1);
		loaderText = (TextView)findViewById(R.id.loadertext);
		new PrefetchData().execute();

	}

	/**
	 * Async Task to make http call
	 */
	private class PrefetchData extends AsyncTask<Void, Void, Void> {

		@Override
		protected void onPreExecute() {
			super.onPreExecute();
			// before making http calls  
			spinner.setVisibility(View.VISIBLE);	
			spinner.setProgress(0);
			spinner.setMax(100);
		}

		@Override
		protected Void doInBackground(Void... arg0) {
			/*
			 * Will make http call here This call will download required data
			 * before launching the app */
			int x = 0;
			b = getIntent().getExtras();
			id = ""+b.getInt("key");
			uname = b.getString("uname");

			List<NameValuePair> nameValuePairs = new ArrayList<NameValuePair>();
			nameValuePairs.add(new BasicNameValuePair("limit", "500"));
			x=5;
			if(LingoServerQuery.executeQuery(nameValuePairs, "getWordList", id)) {
				Log.i("Wordlist acuired: " , "Success");
				for(int i = 0; i < db.getAllWords().size(); i++){
					x = i;
					List<NameValuePair> wordPair = new ArrayList<NameValuePair>();
					wordPair.add(new BasicNameValuePair("id_word", db.getAllWords().get(i).getID_WORD()));
					LingoServerQuery.executeQuery(wordPair, "getWord", id);
					if(x < 80 ){
						spinner.setProgress(x);
					}
				}
				spinner.setProgress(80);
				//Update user with the different points
				if(LingoServerQuery.getUpdateNeeded()){
					for(int i = 0; i < db.getAllUsers().size(); i++){
						String userID = db.getAllUsers().get(i).getID_USER();
						int points = updateCategoryAmount(userID)+
								updateImageAmount(userID)+
								updateAudioAmount(userID)+
								updateFlagAmount(userID)+
								db.getAllWordsByUser(userID).size()+
								updateLinkAmount(userID);
						User user = db.getUser(userID);
						user.setCATEGORYPOINTS(""+updateCategoryAmount(userID));
						user.setIMAGEPOINTS(""+updateImageAmount(userID));
						user.setAUDIOPOINTS(""+updateAudioAmount(userID));
						user.setFLAGPOINTS(""+updateFlagAmount(userID));
						user.setPOSTPOINTS(""+db.getAllWordsByUser(userID).size());	
						user.setLINKPOINTS(""+updateLinkAmount(userID));
						user.setPOINTS(""+points );
						x++;
						db.updateUser(user);
						if(x > 95){
							spinner.setProgress(x);
						}
					}
				}
			} else {
				Log.i("UPDATE" , "Failed / No updated needed");
			}
			spinner.setProgress(100);
			return null;
		}
		private int updateCategoryAmount(String id){
			List<String> catList = new ArrayList<String>();			
			catList = db.getAllCatsByUser(id);			
			HashMap<String, Integer> catPointsHashMap = new HashMap<String, Integer>();
			for(int i = 0; i < catList.size(); i++) {
				catPointsHashMap.put(catList.get(i), +1);
			}
			Log.i("updateCategoryAmount is" , "" + db.getAllCatsByUser(id).size());
			return catPointsHashMap.size();
		}

		private int updateImageAmount(String id){
			List<String> list = new ArrayList<String>();			
			list = db.getAllImagesByUser(id);			
			HashMap<String, Integer> hashMap = new HashMap<String, Integer>();
			for(int i = 0; i < list.size(); i++) {
				hashMap.put(list.get(i), +1);
			}
			Log.i("updateImageAmount is" , "" + db.getAllImagesByUser(id).size());
			return (hashMap.size()-1);
		}

		private int updateAudioAmount(String id){
			List<String> list = new ArrayList<String>();			
			list = db.getAllAudioByUser(id);			
			HashMap<String, Integer> hashMap = new HashMap<String, Integer>();
			for(int i = 0; i < list.size(); i++) {
				hashMap.put(list.get(i), +1);
			}
			Log.i("Updateaudioamount is" , "" + db.getAllAudioByUser(id).size());
			return (hashMap.size()-1);
		}

		private int updateFlagAmount(String id){
			List<String> list = new ArrayList<String>();			
			list = db.getAllFlagsByUser(id);			
			HashMap<String, Integer> hashMap = new HashMap<String, Integer>();
			for(int i = 0; i < list.size(); i++) {
				hashMap.put(list.get(i), +1);
			}
			Log.i("Updateflagamount is" , "" + db.getAllFlagsByUser(id).size());
			return (hashMap.size()-1);
		}

		private int updateLinkAmount(String id){
			List<String> list = new ArrayList<String>();			
			list = db.getAllLinksByUser(id);			
			HashMap<String, Integer> hashMap = new HashMap<String, Integer>();
			for(int i = 0; i < list.size(); i++) {
				hashMap.put(list.get(i), +1);
			}
			Log.i("UpdateLinkAmount is" , "" + db.getAllLinksByUser(id).size());
			return (hashMap.size()-1);
		}

		@Override
		protected void onPostExecute(Void result) {
			super.onPostExecute(result);
			// After completing http call
			// will close this activity and lauch main activity

			b.putInt("key", Integer.parseInt(id)); //Your id
			Intent intent = new Intent(SplashScreen.this, MenuActivity.class);
			intent.putExtras(b); //Put your id to your next Intent
			startActivity(intent);
			finish();

		}
	}
	@Override
	public void onBackPressed() {
	}
}