package com.example.lingobeemod;

import java.util.ArrayList;

import com.google.analytics.tracking.android.EasyTracker;

import android.app.Activity;
import android.app.ListActivity;
import android.content.Intent;
import android.os.Bundle;
import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.ListView;
import android.widget.RelativeLayout;
import android.widget.Toast;


public class TopViewActivity extends Activity {
	private CustomAdapter adapter;
	private Bundle b;
	private String ID; 
	private ListView lv;
	private ArrayList<Custom> users = new ArrayList<Custom>();
	private InternalDatabaseHandler db = new InternalDatabaseHandler(this);
	private static RelativeLayout aboutTopView; 

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_top_view);
		EasyTracker.getInstance(this).activityStart(this);  
		aboutTopView = (RelativeLayout) findViewById(R.id.aboutTopView);

		b = getIntent().getExtras();
		ID = ""+b.getInt("key");

		if(db.getTopUsers().size() < 9) {
			for(int i = 0; i < db.getTopUsers().size(); i++){
				String userID = db.getTopUsers().get(i).getID_USER();
				String s1 = ""+ (i+1);
				String s2 = db.getUser(userID).getUSERNAME();
				String s3 = db.getUser(userID).getPOINTS();
				String s4 = userID;
				Custom c = new Custom(s1,s2,s3,s4);
				if(Integer.parseInt(s3) > 0) {
					users.add(c);			
				}
			}
		}else {
			for(int i = 0; i < db.getTopUsers().size(); i++){
				String userID = db.getTopUsers().get(i).getID_USER();
				String s1 = ""+ (i+1);
				String s2 = db.getUser(userID).getUSERNAME();
				String s3 = db.getUser(userID).getPOINTS();
				String s4 = userID;
				Custom c = new Custom(s1,s2,s3,s4);
				if(Integer.parseInt(s3) > 0) {
					users.add(c);			
				}
			}
		}

		lv = (ListView) findViewById(R.id.topListView);
		adapter = new CustomAdapter(this, R.id.topLayout, users);
		lv.setAdapter(adapter);	
		lv.setOnItemClickListener(clickedItem);

	}

	private OnItemClickListener clickedItem = new OnItemClickListener() {
		@Override
		public void onItemClick(AdapterView<?> parent, View v, int i, long l) {  
			String userId = users.get(i).getUser();
			Log.i("Userclicked: ", ""+userId);
			startAchievementActivity(userId);

		}                
	};
	public void startAchievementActivity(String ID){
		Bundle b = new Bundle();
		b.putInt("key", Integer.parseInt(ID)); 

		Intent intent = new Intent(this, UserViewActivity.class);
		intent.putExtras(b); 
		EasyTracker.getInstance(this).activityStop(this);
		startActivity(intent);
	}

	public void backButtonPressed(View v){
		EasyTracker.getInstance(this).activityStop(this);
		finish();
	}

	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		// Handle presses on the action bar items
		switch (item.getItemId()) {
		case R.id.action_top:
			RelativeLayout rl = (RelativeLayout) findViewById(R.id.aboutTopView);
			rl.setVisibility(View.VISIBLE);
			return true;
		default:
			return super.onOptionsItemSelected(item);
		}
	}

	public void closeAbout(View v){
		RelativeLayout rl = (RelativeLayout) findViewById(R.id.aboutTopView);
		rl.setVisibility(View.GONE);
	}
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.top_view, menu);
		return true;
	}
}