package com.example.lingobeemod;

import com.google.analytics.tracking.android.EasyTracker;

import android.os.Bundle;
import android.app.ActionBar;
import android.app.ActionBar.Tab;
import android.app.Activity;
import android.app.FragmentTransaction;
import android.content.SharedPreferences;
import android.graphics.Point;
import android.graphics.drawable.Drawable;
import android.util.Log;
import android.view.Display;
import android.view.Gravity;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.ViewGroup.LayoutParams;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.RelativeLayout;
import android.widget.TextView;

public class UserViewActivity extends Activity {

	private static TextView userId;
	private static TextView postAmounts;
	private static TextView points;
	private static TextView categoryAmounts;
	private static TextView imageAmounts;
	private static TextView userNameView;
	private static TextView audiAmounts;
	private static TextView linkAmounts;
	private static TextView flagAmounts;
	private static TextView rankedView;
	private static int userPoints;
	private static int audioPoints;
	private static int linkPoints; 
	private static int imagePoints;
	private static int postPoints;
	private static int categoryPoints;
	private static RelativeLayout aboutRelativeView;
	private static String userName;
	private static String ranked;
	private static int flaggedPoints;
	private static int width; 
	private static LinearLayout ll;
	private static LinearLayout.LayoutParams layoutPicture;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);

		InternalDatabaseHandler db = new InternalDatabaseHandler(this);
		Bundle b = getIntent().getExtras();
		int id = b.getInt("key");

		User you = db.getUser(""+id);
		aboutRelativeView = (RelativeLayout) findViewById(R.id.aboutRelativeView);
		userPoints = Integer.parseInt(you.getPOINTS());
		audioPoints = Integer.parseInt(you.getAUDIOPOINTS());
		linkPoints = Integer.parseInt(you.getLINKPOINTS());
		flaggedPoints = Integer.parseInt(you.getFLAGPOINTS());
		postPoints = Integer.parseInt(you.getPOSTPOINTS());
		imagePoints = Integer.parseInt(you.getIMAGEPOINTS());
		categoryPoints = Integer.parseInt(you.getCATEGORYPOINTS());
		userName = you.getUSERNAME();

		setContentView(R.layout.activity_user_view);

		postAmounts = (TextView)findViewById(R.id.postAmountsEditText);
		postAmounts.setText(you.getPOSTPOINTS());

		points = (TextView)findViewById(R.id.pointAmountEditText);
		points.setText(you.getPOINTS());

		userNameView = (TextView)findViewById(R.id.usernameTextView);
		userNameView.setText(you.getUSERNAME());
		
		rankedView = (TextView)findViewById(R.id.userRankingTextView);
		String ranked = "0";
		for(int i = 0; i < db.getTopUsers().size(); i++){
			if(db.getTopUsers().get(i).getID_USER().equals(you.getID_USER())){
				int j = i+1;
				ranked = ""+j;
			}
		}
		rankedView.setText(ranked);
		
		
		categoryAmounts = (TextView)findViewById(R.id.categoryAmountsEditText);
		categoryAmounts.setText(you.getCATEGORYPOINTS());

		audiAmounts = (TextView)findViewById(R.id.audioAmountsEditText);
		audiAmounts.setText(you.getAUDIOPOINTS());

		imageAmounts = (TextView)findViewById(R.id.imageAmountsEditText);
		imageAmounts.setText(you.getIMAGEPOINTS());

		flagAmounts = (TextView)findViewById(R.id.flagAmountsEditText);
		flagAmounts.setText(you.getFLAGPOINTS());

		linkAmounts = (TextView)findViewById(R.id.linkAmountsEditText);
		linkAmounts.setText(you.getLINKPOINTS());



		Display d = getWindowManager().getDefaultDisplay();
		Point size = new Point();
		d.getSize(size);
		width = size.x;		
		ll = (LinearLayout) findViewById(R.id.achievementView);
		layoutPicture = new LinearLayout.LayoutParams(
				(width/3), 
				(width/3));
		layoutPicture.gravity = Gravity.CENTER_VERTICAL;
		EasyTracker.getInstance(this).activityStart(this);  
		checkPostAchievements();
		checkFlaggedAchievements();
		checkAudioAchievements();
		checkImageAchievements();
		checkLinkAchievements();
		checkCategoryAchievement();
		

		for(int i = 0; i < db.getAllUsers().size(); i++){
			String iden = db.getAllUsers().get(i).getID_USER();
			Log.i("USER NR " + i, "" + db.getUser(iden).getPOINTS());
		}
	}

	public void addAchievement(int pointsachievement, String text){
		ImageView iv = new ImageView(this);
		TextView tv = new TextView(this);
		tv.setGravity(Gravity.CENTER);
		tv.setPadding(15, 0, 0, 0);
		LinearLayout horLin = new LinearLayout(this);
		horLin.setOrientation(LinearLayout.HORIZONTAL);
		horLin.setLayoutParams(new LayoutParams(LayoutParams.MATCH_PARENT, LayoutParams.WRAP_CONTENT));

		tv.setText(text);			
		iv.setImageResource(pointsachievement);
		horLin.setWeightSum(3.0f);
		tv.setLayoutParams(new LinearLayout.LayoutParams(LayoutParams.MATCH_PARENT, 0, 2.0f));
		iv.setLayoutParams(new LinearLayout.LayoutParams(LayoutParams.MATCH_PARENT, 0, 1.0f));
		horLin.addView(iv, layoutPicture);
		horLin.addView(tv, layoutPicture);
		horLin.setPadding(10, 10, 10, 10);
		
		ll.addView(horLin);
		Log.i("ADDING ACHIEVEMENT", "");
	}

	public void checkCategoryAchievement(){
		if(categoryPoints > 2){
			int categoryPicture = R.drawable.categories;
			String text = "Category king";
			addAchievement(categoryPicture, text);
		}
	}
	
	public void checkAudioAchievements(){
		if(audioPoints > 1) {
			int postPointPicture1 = R.drawable.audioachievement1;
			String text = "Bringing the noise";
			addAchievement(postPointPicture1, text);
		}
		if(audioPoints > 2) {
			int postPointPicture2 = R.drawable.audioachievement2;
			String text = "Raising the roof";
			addAchievement(postPointPicture2, text);
		}
	}

	public void checkLinkAchievements(){
		if(linkPoints > 2) {
			int linkPointImage = R.drawable.link5;
			String text = "Bringing forth the extra information";
			addAchievement(linkPointImage, text);
		}
		if(linkPoints > 3) {
			int linkPointImage2 = R.drawable.links10;
			String text = "Trustable source";
			addAchievement(linkPointImage2, text);
		}

	}

	public void checkImageAchievements(){
		if(imagePoints > 1) {
			int imagePointPicture = R.drawable.image3;
			String text = "A picture says more than a thousand words";
			addAchievement(imagePointPicture, text);
		}
		if(imagePoints > 3) {
			int imagePointPicture2 = R.drawable.image7;
			String text = "Photographer?";
			addAchievement(imagePointPicture2, text);
		}
		if(imagePoints > 4) {
			int imagePointPicture3 = R.drawable.images10;
			String text = "Professional tourist";
			addAchievement(imagePointPicture3, text);
		}
	}

	public void checkFlaggedAchievements(){
		if(flaggedPoints >= 1) {
			int postPointPicture1 = R.drawable.firstflaggedachievement;
			String text = "Not the most\ntrustable person";
			addAchievement(postPointPicture1, text);
		}
		if(flaggedPoints >= 2) {
			int postPointPicture2 = R.drawable.secondflagged;
			String text = "Me fail english?\nUnpossible";
			addAchievement(postPointPicture2, text);
		}

	}

	public void checkPostAchievements(){
		if(postPoints >= 1) {

			int postPointPicture1 = R.drawable.post5achievement;
			String text = "Active contributor";
			addAchievement(postPointPicture1, text);
		}
		if(postPoints >= 3) {
			int postPointPicture2 = R.drawable.post10achievement;
			String text = "Fact bringer";
			addAchievement(postPointPicture2, text);
		}
		if(postPoints >= 5) {
			int postPointPicture3 = R.drawable.post15achievement;
			String text = "Spreading the knowledge";
			addAchievement(postPointPicture3, text);
		}
		if(postPoints >= 7) {
			int postPointPicture4 = R.drawable.post20achievement;
			String text = "Superior contributor";
			addAchievement(postPointPicture4, text);
		}
		if(postPoints >= 10) {
			int postPointPicture5 = R.drawable.post30achievement;
			String text = "Are all these posts real?";
			addAchievement(postPointPicture5, text);
		}
	}

	public void backButtonPressed(View v){
		EasyTracker.getInstance(this).activityStop(this);
		finish();
	}
	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.user_view, menu);
		return true;
	}
	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		// Handle presses on the action bar items
		switch (item.getItemId()) {
		case R.id.action_about_user:
			RelativeLayout rl = (RelativeLayout) findViewById(R.id.aboutRelativeView);
			rl.setVisibility(View.VISIBLE);
			return true;
		default:
			return super.onOptionsItemSelected(item);
		}
	}

	public void closeAbout(View v) {
		RelativeLayout rl = (RelativeLayout) findViewById(R.id.aboutRelativeView);
		rl.setVisibility(View.GONE);
	}
}
